
import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class MareMosso extends Applet implements Runnable{

/*<applet code="MareMosso.class" width = 150 height = 200>
<param name="sleep" value ="200">
<param name="angolo" value="0.9">
<param name="Image" value="mare3.gif">
</applet>*/


Thread runner;
double inc = 0.0;
int w,h,s;
PixelGrabber pg;
int[] pix, movpix;
double C = 0.0;
int yadj = 0;
double RAD = Math.PI/180;
double ang_deg = 0.0;
double ang_rad = 0.0;

Image miaIm,img,buff_im;
Graphics m_g;
String S;

public void init(){
	s = Integer.parseInt(getParameter("sleep"));
	inc = Double.valueOf(getParameter("angolo")).doubleValue();
	S = getParameter("Image");
	img = getImage(getCodeBase(),S);
	
	try{
		MediaTracker track = new MediaTracker(this);
		track.addImage(img,0);
		track.waitForID(0);
	}catch(InterruptedException e){};
	
	buff_im = img;
	w = img.getWidth(this);
	h = img.getHeight(this);
	pix = new int[w*h];
	movpix = new int[w*h];
	miaIm = createImage(w,h);
	m_g = miaIm.getGraphics();
	try{
	pg = new PixelGrabber(img,0,0,w,h,pix,0,w);
	pg.grabPixels();
	}catch(InterruptedException e){};
	
	
	}	

public void paint(Graphics g){
	m_g.drawImage(buff_im,0,0,this);
	g.drawImage(miaIm,0,0,this);
	}

public void start(){
	if(runner == null){
		runner = new Thread(this);
		runner.start();
		}
	}


public void run(){
	Thread thisThread = Thread.currentThread();
  	while(runner == thisThread) {
  		try{
  			y_moveImage();
  			repaint();
  			Thread.sleep(s);
  		}
  		catch(InterruptedException e){};
  		
  		
  	}
}

  		

public void stop(){
	if(runner != null){
		runner = null;
	}
}

public void y_moveImage(){
	
	for(int i=0; i < w-1; i++){
		ang_deg  += inc;
		if(ang_deg > 360){ ang_deg = 0;}
		ang_rad = 2*ang_deg * RAD;
		C = Math.cos(ang_rad);
		
		int facriga = (w+i)/w +5;//la riga +1+5
		yadj = (int)(facriga*C);//facriga costante su ogni riga, ma C varia con i
		for(int j=0; j < h-1; j++){
			if( ( w*(j+yadj)+i >=0 )&&( w*(j+yadj)+i <= w*h-1)){
		movpix[w*(j+yadj)+i] = pix[w*j+i];
				}
			}//fine for int j=0
		}//fine for int i =0
	buff_im = createImage(new MemoryImageSource(w,h,movpix,0,w));
	}//fine metodo

public void update(Graphics g){
	paint(g);
	}
}
		
	
	

